'use strict';

const Person = function() {
  console.log('Person created...');
}
Person.prototype.play = function() {
  console.log('playing...');
}

//"delegation is better than inheritance"

//class-based inheritance uses inheritance to implement reuse

//prototypal inheritance uses delegation to implement reuse

const sam = new Person();
sam.play();

const SpecialPerson = function() {}
SpecialPerson.prototype = new Person();

const jake = new SpecialPerson();
jake.play();

//Objects for a chain, where an object has as prototype which
//in turn has a prototype, which in turn has...
//until you get to the last one which has no prototype