'use strict';

class Vehicle {
  constructor() {
    this.miles = 0;
  }                
  
  drive(dist) {
    console.log(`Vehilcle's drive`);
    this.miles += dist;
  }
}

class Car extends Vehicle {
  constructor(year) {
    super();
    this.year = year;
  }
}

const car1 = new Car(2018);
const car2 = new Car(2018);
console.log(car1.miles);

car1.drive(10);
console.log(car1.miles);

//This extends may be very mileading. It is not class-based
//inheritance. It is still protoypal inheritance

class Base {
  constructor() {
    this.miles = 0;
  }                
  
  drive(dist) { 
    console.log("some other drive");
    this.miles += dist;
  }  
}

Object.setPrototypeOf(Object.getPrototypeOf(car1), new Base());
car1.drive(10);
car2.drive(10);

new Car().drive(11);
             
//still prototypal inheritance
//use caution